Index: test/org/mifos/application/reports/business/service/AbstractCollectionSheetTestCase.java
===================================================================
--- test/org/mifos/application/reports/business/service/AbstractCollectionSheetTestCase.java	(revision 0)
+++ test/org/mifos/application/reports/business/service/AbstractCollectionSheetTestCase.java	(revision 0)
@@ -0,0 +1,83 @@
+package org.mifos.application.reports.business.service;
+
+import static org.mifos.application.reports.ui.SelectionItem.ALL_CENTER_SELECTION_ITEM;
+import static org.mifos.application.reports.ui.SelectionItem.ALL_LOAN_OFFICER_SELECTION_ITEM;
+import static org.mifos.framework.util.helpers.NumberUtils.*;
+import java.sql.Date;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.mifos.application.collectionsheet.business.CollSheetCustBO;
+import org.mifos.application.customer.util.helpers.CustomerLevel;
+import org.mifos.application.personnel.business.PersonnelBO;
+import org.mifos.application.personnel.business.PersonnelFixture;
+import org.mifos.framework.MifosTestCase;
+import org.mifos.framework.util.helpers.DateUtils;
+import org.mifos.framework.util.helpers.NumberUtils;
+
+public class AbstractCollectionSheetTestCase extends MifosTestCase {
+
+	protected static final Integer ANY_ID = new Integer("1");
+	protected static final Short ANY_SHORT_ID = NumberUtils
+			.convertIntegerToShort(ANY_ID);
+	protected static final Integer BRANCH_ID = Integer.valueOf(400);
+	protected static final Short BRANCH_SHORT_ID = NumberUtils
+			.convertIntegerToShort(BRANCH_ID);
+	protected static final Integer CENTER_ID = Integer.valueOf(500);
+	protected static final Integer LOAN_OFFICER_ID = Integer.valueOf(600);
+	protected static final Short LOAN_OFFICER_SHORT_ID = Short
+			.valueOf(LOAN_OFFICER_ID.shortValue());
+	protected static final int GROUP_ID = Integer.valueOf(200);
+	protected static final Integer ANOTHER_GROUP_ID = Integer.valueOf(201);
+	protected static final Date TODAYS_DATE = DateUtils.currentDateAsSqlDate();
+	protected static final int MAX_COUNT = 10;
+	protected static final Integer ALL_CENTER_ID = convertShortToInteger(ALL_CENTER_SELECTION_ITEM
+			.getId());
+	protected static final Short ALL_LOAN_OFFICER_SHORT_ID = ALL_LOAN_OFFICER_SELECTION_ITEM
+			.getId();
+	protected static final Integer ALL_LOAN_OFFICER_ID = NumberUtils
+			.convertShortToInteger(ALL_LOAN_OFFICER_SHORT_ID);
+	protected static final PersonnelBO LOAN_OFFICER = PersonnelFixture
+			.createLoanOfficer(LOAN_OFFICER_SHORT_ID);
+	protected CollectionSheetService collectionSheetService;
+	protected CollSheetCustBO center;
+	protected CollSheetCustBO group;
+
+	protected Integer s2i(Short s) {
+		return NumberUtils.convertShortToInteger(s);
+	}
+
+	protected Short i2s(Integer s) {
+		return NumberUtils.convertIntegerToShort(s);
+	}
+
+	protected List<CollSheetCustBO> generateClientCollectionSheets(
+			int idStartFrom, CollSheetCustBO parentGroup, Short loanOfficerId) {
+		List<CollSheetCustBO> generatedCollectionSheets = new ArrayList<CollSheetCustBO>();
+		for (int i = idStartFrom; i < idStartFrom + 2; i++) {
+			CollSheetCustBO customer = generateCollectionSheet(i,
+					loanOfficerId, CustomerLevel.CLIENT);
+			customer.setParentCustomerId(parentGroup.getCustId());
+			generatedCollectionSheets.add(customer);
+		}
+		return generatedCollectionSheets;
+	}
+
+	protected CollSheetCustBO generateCollectionSheet(int custId,
+			Short loanOfficerId, CustomerLevel customerLevel) {
+		return new CollSheetCustBO(Integer.valueOf(custId),
+				"Sample Individual Customer", customerLevel.getValue(),
+				ANY_SHORT_ID, "", loanOfficerId);
+	}
+
+	@Override
+	protected void setUp() throws Exception {
+		super.setUp();
+		center = new CollSheetCustBO(CENTER_ID, "Sample Center",
+				CustomerLevel.CENTER.getValue(), ANY_SHORT_ID, "",
+				LOAN_OFFICER_SHORT_ID);
+		group = new CollSheetCustBO(GROUP_ID, "Sample Group",
+				CustomerLevel.GROUP.getValue(), ANY_SHORT_ID, "",
+				LOAN_OFFICER_SHORT_ID);
+	}
+}
Index: test/org/mifos/application/reports/business/service/CollectionSheetServiceTest.java
===================================================================
--- test/org/mifos/application/reports/business/service/CollectionSheetServiceTest.java	(revision 0)
+++ test/org/mifos/application/reports/business/service/CollectionSheetServiceTest.java	(revision 0)
@@ -0,0 +1,127 @@
+package org.mifos.application.reports.business.service;
+
+import java.sql.Date;
+import java.util.Calendar;
+import java.util.HashSet;
+import java.util.List;
+
+import org.hibernate.Session;
+import org.hibernate.Transaction;
+import org.mifos.application.collectionsheet.business.CollSheetCustBO;
+import org.mifos.application.collectionsheet.business.CollectionSheetBO;
+import org.mifos.application.collectionsheet.util.helpers.CollectionSheetConstants;
+import org.mifos.application.customer.util.helpers.CustomerLevel;
+import org.mifos.framework.hibernate.helper.HibernateUtil;
+import org.mifos.framework.util.CollectionUtils;
+import org.mifos.framework.util.helpers.DateUtils;
+
+public class CollectionSheetServiceTest extends AbstractCollectionSheetTestCase {
+	private Session session;
+	private Transaction transaction;
+	HashSet<CollSheetCustBO> generatedCollectionSheets;
+	private Date meetingDate;
+	private CollSheetCustBO anotherGroup;
+
+	public void testReturnsCollectionSheetForMeetingDateCenter()
+			throws Exception {
+		List<CollSheetCustBO> retrievedCenterCollectionSheets = collectionSheetService
+				.getCollectionSheetForCustomerOnMeetingDate(meetingDate,
+						CENTER_ID, LOAN_OFFICER_SHORT_ID, CustomerLevel.CENTER);
+		assertEquals(1, retrievedCenterCollectionSheets.size());
+		assertEquals(center, retrievedCenterCollectionSheets.get(0));
+	}
+
+	public void testReturnsCollectionSheetsForGroup() throws Exception {
+		List<CollSheetCustBO> meetingsForGroups = collectionSheetService
+				.getCollectionSheetForGroups(meetingDate, center,
+						LOAN_OFFICER_SHORT_ID);
+		assertEquals(2, meetingsForGroups.size());
+		assertTrue(meetingsForGroups.contains(group));
+		assertTrue(meetingsForGroups.contains(anotherGroup));
+	}
+
+	public void testCollectionSheetForIndividualCustomer() throws Exception {
+		List<CollSheetCustBO> collectionSheet = collectionSheetService
+				.getCollectionSheetForCustomers(meetingDate, group,
+						LOAN_OFFICER_SHORT_ID);
+		assertEquals(2, collectionSheet.size());
+	}
+
+//	public void testGetCollectionSheetForSpecifiedCenterBranchLoanOfficer()
+//			throws Exception {
+//		List<CollectionSheetBO> collectionSheet = collectionSheetService
+//				.getCollectionSheet(BRANCH_SHORT_ID, CENTER_ID,
+//						LOAN_OFFICER_SHORT_ID, meetingDate, CustomerLevel.CENTER);
+//		assertEquals(1, collectionSheet.size());
+//	}
+
+	@Override
+	protected void setUp() throws Exception {
+		super.setUp();		
+		collectionSheetService = new CollectionSheetService();
+		CollSheetCustBO centerUnderDifferentLoanOfficer = new CollSheetCustBO(
+				CENTER_ID, "Sample Center Under Different Loan Officer",
+				CustomerLevel.CENTER.getValue(), ANY_SHORT_ID, "", ANY_SHORT_ID);
+		CollSheetCustBO groupUnderDifferentLoanOfficer = new CollSheetCustBO(
+				GROUP_ID, "Sample Group", CustomerLevel.GROUP.getValue(),
+				ANY_SHORT_ID, "", ANY_SHORT_ID);
+		anotherGroup = new CollSheetCustBO(ANOTHER_GROUP_ID,
+				"Another Sample Group", CustomerLevel.GROUP.getValue(),
+				ANY_SHORT_ID, "", LOAN_OFFICER_SHORT_ID);
+
+		generatedCollectionSheets = new HashSet<CollSheetCustBO>();
+		group.setParentCustomerId(CENTER_ID);
+		groupUnderDifferentLoanOfficer.setParentCustomerId(CENTER_ID);
+		anotherGroup.setParentCustomerId(CENTER_ID);
+		generatedCollectionSheets.add(center);
+		generatedCollectionSheets.add(centerUnderDifferentLoanOfficer);
+		generatedCollectionSheets.add(group);
+		generatedCollectionSheets.add(groupUnderDifferentLoanOfficer);
+		generatedCollectionSheets.add(anotherGroup);
+
+
+		generatedCollectionSheets.addAll(generateClientCollectionSheets(300,
+				group, LOAN_OFFICER_SHORT_ID));
+		generatedCollectionSheets.addAll(generateClientCollectionSheets(302,
+				anotherGroup, LOAN_OFFICER_SHORT_ID));
+		generatedCollectionSheets.addAll(generateClientCollectionSheets(304,
+				anotherGroup, ANY_SHORT_ID));
+
+		meetingDate = DateUtils.getSqlDate(2001, Calendar.JANUARY, 1);
+		CollectionSheetBO collectionSheetBO = new CollectionSheetBO(
+				meetingDate, TODAYS_DATE, generatedCollectionSheets,
+				CollectionSheetConstants.COLLECTION_SHEET_GENERATION_SUCCESSFUL);
+
+		CollSheetCustBO customerForMeetingDateAfterSpecifiedDate = new CollSheetCustBO(
+				CENTER_ID,
+				"Customer with collectionsheet after specified meeting date",
+				CustomerLevel.CENTER.getValue(), BRANCH_SHORT_ID, "",
+				LOAN_OFFICER_SHORT_ID);
+		CollectionSheetBO collectionSheetBOForCenterBranchLoanOfficer = new CollectionSheetBO(
+				DateUtils.getSqlDate(2002, Calendar.FEBRUARY, 2), TODAYS_DATE,
+				CollectionUtils.asSet(customerForMeetingDateAfterSpecifiedDate),
+				CollectionSheetConstants.COLLECTION_SHEET_GENERATION_SUCCESSFUL);
+		
+		CollSheetCustBO customerForMeetingDateBeforeSpecifiedDate = new CollSheetCustBO(
+				CENTER_ID,
+				"Customer with collection sheet before meeting date",
+				CustomerLevel.CENTER.getValue(), BRANCH_SHORT_ID, "",
+				LOAN_OFFICER_SHORT_ID);
+		CollectionSheetBO collectionSheetBOBeforeSpecifiedMeetingDate = new CollectionSheetBO(
+				DateUtils.getSqlDate(2000, Calendar.DECEMBER, 31), TODAYS_DATE,
+				CollectionUtils.asSet(customerForMeetingDateBeforeSpecifiedDate),
+				CollectionSheetConstants.COLLECTION_SHEET_GENERATION_SUCCESSFUL);
+
+		session = HibernateUtil.getSessionTL();
+		transaction = session.beginTransaction();
+		session.save(collectionSheetBO);
+		session.save(collectionSheetBOForCenterBranchLoanOfficer);
+		session.save(collectionSheetBOBeforeSpecifiedMeetingDate);
+	}
+
+	@Override
+	protected void tearDown() throws Exception {
+		super.tearDown();
+		transaction.rollback();
+	}
+}
Index: test/org/mifos/application/reports/business/CollectionSheetReportParametersTest.java
===================================================================
--- test/org/mifos/application/reports/business/CollectionSheetReportParametersTest.java	(revision 0)
+++ test/org/mifos/application/reports/business/CollectionSheetReportParametersTest.java	(revision 0)
@@ -0,0 +1,103 @@
+package org.mifos.application.reports.business;
+
+import static org.easymock.classextension.EasyMock.createMock;
+import static org.easymock.classextension.EasyMock.replay;
+import static org.easymock.classextension.EasyMock.verify;
+import static org.mifos.application.reports.ui.SelectionItem.NA_CENTER_SELECTION_ITEM;
+import static org.mifos.application.reports.ui.SelectionItem.NA_LOAN_OFFICER_SELECTION_ITEM;
+import static org.mifos.application.reports.ui.SelectionItem.SELECT_BRANCH_OFFICE_SELECTION_ITEM;
+import static org.mifos.application.reports.ui.SelectionItem.SELECT_CENTER_SELECTION_ITEM;
+import static org.mifos.application.reports.ui.SelectionItem.SELECT_LOAN_OFFICER_SELECTION_ITEM;
+
+import java.text.ParseException;
+
+import org.mifos.application.reports.business.validator.Errors;
+import org.mifos.framework.MifosTestCase;
+
+
+public class CollectionSheetReportParametersTest extends MifosTestCase {
+
+	private static final String VALID_DATE = "07/03/2007 12:00:00 AM";
+	private static final String VALID_ID = "0";
+	private CollectionSheetReportParameters reportParams;
+	private Errors errorsMock;
+
+	public void testValidatorReturnsErrorIfBranchIdIsSelect() throws Exception {
+		reportParams = new CollectionSheetReportParameters(String
+				.valueOf(SELECT_BRANCH_OFFICE_SELECTION_ITEM
+						.getId()), VALID_ID, VALID_ID, VALID_DATE);
+		errorsMock.rejectValue("branchId", "branchId.invalid");
+		replay(errorsMock);
+		reportParams.validate(errorsMock);
+		verify(errorsMock);
+	}
+
+	public void testValidatorReturnsLoanOfficerInvalidIfLoanOfficerIsSelect()
+			throws Exception {
+		reportParams = new CollectionSheetReportParameters(VALID_ID, String
+				.valueOf(SELECT_LOAN_OFFICER_SELECTION_ITEM
+						.getId()), VALID_ID, VALID_DATE);
+		errorsMock.rejectValue("loanOfficerId", "loanOfficerId.invalid");
+		replay(errorsMock);
+		reportParams.validate(errorsMock);
+		verify(errorsMock);
+	}
+
+	public void testValidatorReturnsLoanOfficerInvalidIfLoanOfficerIsNA()
+			throws Exception {
+		reportParams = new CollectionSheetReportParameters(VALID_ID, String
+				.valueOf(NA_LOAN_OFFICER_SELECTION_ITEM
+						.getId()), VALID_ID, VALID_DATE);
+		errorsMock.rejectValue("loanOfficerId", "loanOfficerId.invalid");
+		replay(errorsMock);
+		reportParams.validate(errorsMock);
+		verify(errorsMock);
+	}
+
+	public void testValidatorReturnsCenterInvalidIfCenterIsSelect()
+			throws Exception {
+		reportParams = new CollectionSheetReportParameters(VALID_ID, VALID_ID,
+				String.valueOf(SELECT_CENTER_SELECTION_ITEM
+						.getId()), VALID_DATE);
+		errorsMock.rejectValue("centerId", "centerId.invalid");
+		replay(errorsMock);
+		reportParams.validate(errorsMock);
+		verify(errorsMock);
+	}
+
+	public void testValidatorReturnsCenterInvalidIfCenterIsNA()
+			throws Exception {
+		reportParams = new CollectionSheetReportParameters(VALID_ID, VALID_ID,
+				String.valueOf(NA_CENTER_SELECTION_ITEM
+						.getId()), VALID_DATE);
+		errorsMock.rejectValue("centerId", "centerId.invalid");
+		replay(errorsMock);
+		reportParams.validate(errorsMock);
+		verify(errorsMock);
+	}
+
+	public void testValidatorReturnsMeetingDateInvalidIfMeetingDateIsSelect()
+			throws Exception {
+		reportParams = new CollectionSheetReportParameters(VALID_ID, VALID_ID,
+				VALID_ID, VALID_DATE);
+		replay(errorsMock);
+		reportParams.validate(errorsMock);
+		verify(errorsMock);
+	}
+
+	public void testReportDateFormat() throws Exception {
+		try {
+			CollectionSheetReportParameters.REPORT_DATE_PARAM_FORMAT
+					.parse("01/01/1970 05:30:00 AM");
+		}
+		catch (ParseException e) {			
+			fail("Should be parsing given date");
+		}		
+	}
+	
+	@Override
+	protected void setUp() throws Exception {
+		super.setUp();
+		errorsMock = createMock(Errors.class);
+	}
+}
Index: test/org/mifos/application/reports/ui/SelectionItemTest.java
===================================================================
--- test/org/mifos/application/reports/ui/SelectionItemTest.java	(revision 0)
+++ test/org/mifos/application/reports/ui/SelectionItemTest.java	(revision 0)
@@ -0,0 +1,66 @@
+package org.mifos.application.reports.ui;
+
+import java.util.List;
+
+import org.mifos.application.reports.persistence.SelectionItemPersistence;
+import org.mifos.framework.MifosTestCase;
+
+public class SelectionItemTest extends MifosTestCase {
+	private static final Short LOAN_OFFICER_ID = Short.valueOf("1");
+	private static final Short BRANCH_ID = Short.valueOf("3");
+	private SelectionItemPersistence selectionItemPersistence;
+
+	public void testRetrievesOfficesThroughNamedQuery() throws Exception {
+		List<SelectionItem> activeBranchesUnderUser = null;
+		try {
+			activeBranchesUnderUser = selectionItemPersistence
+					.getActiveBranchesUnderUser("1.1");
+		}
+		catch (Exception e) {
+			fail("Should not fail while retrieving SelectionItem");
+		}
+		assertFalse(activeBranchesUnderUser.isEmpty());
+	}
+
+	public void testRetrievesLoanOfficersThroughNamedQuery() throws Exception {
+		List<SelectionItem> activeLoanOfficers = null;
+		try {
+			activeLoanOfficers = selectionItemPersistence
+					.getActiveLoanOfficersUnderOffice(Short.valueOf("2"));
+		}
+		catch (Exception e) {
+			fail("Should not fail while retrieving SelectionItem");
+		}
+		assertFalse(activeLoanOfficers.isEmpty());
+	}
+
+	public void testRetrievesActiveCentersThroughNamedQuery() throws Exception {
+		List<SelectionItem> activeCentersUnderUser = null;
+		try {
+			activeCentersUnderUser = selectionItemPersistence
+					.getActiveCentersUnderUser(BRANCH_ID, LOAN_OFFICER_ID);
+		}
+		catch (Exception e) {
+			fail("Should not fail while retrieving SelectionItem");
+		}
+		assertFalse(activeCentersUnderUser.isEmpty());
+	}
+
+	public void testRetrievesActiveGroupsThroughNamedQuery() throws Exception {
+		List<SelectionItem> activeGroupsUnderUser = null;
+		try {
+			activeGroupsUnderUser = selectionItemPersistence
+					.getActiveGroupsUnderUser(BRANCH_ID, LOAN_OFFICER_ID);
+		}
+		catch (Exception e) {
+			fail("Should not fail while retrieving SelectionItem");
+		}
+		assertFalse(activeGroupsUnderUser.isEmpty());
+	}
+
+	@Override
+	protected void setUp() throws Exception {
+		super.setUp();
+		selectionItemPersistence = new SelectionItemPersistence();
+	}
+}
Index: test/org/mifos/application/reports/ui/SelectionItemFixture.java
===================================================================
--- test/org/mifos/application/reports/ui/SelectionItemFixture.java	(revision 0)
+++ test/org/mifos/application/reports/ui/SelectionItemFixture.java	(revision 0)
@@ -0,0 +1,12 @@
+package org.mifos.application.reports.ui;
+
+import static org.mifos.framework.util.helpers.NumberUtils.*;
+public class SelectionItemFixture {
+	public static SelectionItem createSelectionItem(Integer id) {
+		return new SelectionItem(convertIntegerToShort(id), "");
+	}
+
+	public static SelectionItem createSelectionItem(Short personnelId) {
+		return new SelectionItem(personnelId, "");
+	}
+}
Index: test/org/mifos/application/office/business/OfficecFixture.java
===================================================================
--- test/org/mifos/application/office/business/OfficecFixture.java	(revision 12247)
+++ test/org/mifos/application/office/business/OfficecFixture.java	(working copy)
@@ -8,4 +8,7 @@
 		return office;
 	}
 
+	public static OfficeBO createOffice(Short officeId) {
+		return new OfficeBO(officeId, "Some Office", null, null);
+	}
 }
Index: test/org/mifos/application/ApplicationTestSuite.java
===================================================================
--- test/org/mifos/application/ApplicationTestSuite.java	(revision 12247)
+++ test/org/mifos/application/ApplicationTestSuite.java	(working copy)
@@ -142,8 +142,9 @@
 		suite.addTest(SurveysTestSuite.suite());
 		suite.addTest(PPITestSuite.suite());
 		suite.addTest(ApplicationAcceptedPaymentTypeTestSuite.suite());
-		
+		suite.addTest(CollectionSheetTestSuite.suite());
 		return suite;
 	}
 }
 
+
Index: test/org/mifos/application/personnel/business/CustomerFixture.java
===================================================================
--- test/org/mifos/application/personnel/business/CustomerFixture.java	(revision 0)
+++ test/org/mifos/application/personnel/business/CustomerFixture.java	(revision 0)
@@ -0,0 +1,26 @@
+package org.mifos.application.personnel.business;
+
+import org.mifos.application.customer.business.CustomerBO;
+import org.mifos.application.customer.business.CustomerLevelEntity;
+import org.mifos.application.customer.center.business.CenterBO;
+import org.mifos.application.customer.group.business.GroupBO;
+import org.mifos.application.customer.util.helpers.CustomerLevel;
+
+public class CustomerFixture {
+
+	public static CenterBO createCenterBO(Integer customerId) {
+		return createCenterBO(customerId, null);
+	}
+
+	public static CenterBO createCenterBO(Integer customerId,
+			PersonnelBO loanOfficer) {
+		CenterBO center = new CenterBO(customerId, new CustomerLevelEntity(
+				CustomerLevel.CENTER), null, loanOfficer, customerId.toString());
+		return center;
+	}
+	
+	public static GroupBO createGroupBO(Integer customerId, PersonnelBO loanOfficer) {
+		return new GroupBO(customerId, new CustomerLevelEntity(
+				CustomerLevel.CENTER), null, loanOfficer, customerId.toString());
+	}
+}
Index: test/org/mifos/application/personnel/business/PersonnelFixture.java
===================================================================
--- test/org/mifos/application/personnel/business/PersonnelFixture.java	(revision 12247)
+++ test/org/mifos/application/personnel/business/PersonnelFixture.java	(working copy)
@@ -2,6 +2,7 @@
 
 import org.mifos.application.office.business.OfficeBO;
 import org.mifos.application.office.business.OfficecFixture;
+import org.mifos.application.personnel.util.helpers.PersonnelLevel;
 
 public class PersonnelFixture {
 
@@ -12,4 +13,23 @@
 		return personnel;
 	}
 
+	public static PersonnelBO createPersonnel(Short personnelId) {
+		PersonnelBO personnel = new PersonnelBO(personnelId, null, null, null);
+		personnel.setOffice(OfficecFixture.createOffice(Short.valueOf("1")));
+		return personnel;
+	}
+
+	public static PersonnelBO createLoanOfficer(Short personnelId) {
+		PersonnelBO personnel = createPersonnel(personnelId);
+		personnel
+				.setLevel(new PersonnelLevelEntity(PersonnelLevel.LOAN_OFFICER));
+		return personnel;
+	}
+
+	public static PersonnelBO createNonLoanOfficer(Short personnelId) {
+		PersonnelBO personnel = createPersonnel(personnelId);
+		personnel.setLevel(new PersonnelLevelEntity(
+				PersonnelLevel.NON_LOAN_OFFICER));
+		return personnel;
+	}
 }
Index: test/org/mifos/framework/util/helpers/MockObjectHelpers.java
===================================================================
--- test/org/mifos/framework/util/helpers/MockObjectHelpers.java	(revision 0)
+++ test/org/mifos/framework/util/helpers/MockObjectHelpers.java	(revision 0)
@@ -0,0 +1,20 @@
+package org.mifos.framework.util.helpers;
+
+import org.easymock.EasyMock;
+import org.easymock.IArgumentMatcher;
+
+public class MockObjectHelpers {
+
+	public static java.sql.Date eqAnySqlDate() {
+		EasyMock.reportMatcher(new IArgumentMatcher() {
+			public void appendTo(StringBuffer message) {
+				return;
+			}
+	
+			public boolean matches(Object other) {
+				return true;
+			}});
+		return null;
+	}	
+
+}
Index: BirtWebViewer/webcontent/birt/pages/parameter/ComboBoxParameterFragment.jsp
===================================================================
--- BirtWebViewer/webcontent/birt/pages/parameter/ComboBoxParameterFragment.jsp	(revision 12247)
+++ BirtWebViewer/webcontent/birt/pages/parameter/ComboBoxParameterFragment.jsp	(working copy)
@@ -29,8 +29,9 @@
 %>
 <!--For Mifos Birt reports-->
 <TR>
-	<TD NOWRAP>
-	</TD>
+    <!-- below TD commented for alignment -->
+	<!-- <TD NOWRAP>
+	</TD>-->
 	<TD NOWRAP class = "fontnormal" align="right">
 	<%if ( parameterBean.isRequired( ) )
 		{
@@ -44,7 +45,8 @@
 		
 		
 	</TD>
-	<TD NOWRAP></TD>
+	<!-- below TD commented for alignment -->
+	<!-- <TD NOWRAP></TD> -->
 	<TD NOWRAP WIDTH="50%">
 		<INPUT TYPE="HIDDEN"
 			ID="<%= encodedParameterName + "_value" %>"
@@ -157,4 +159,4 @@
 	%>
 	</TD>
 </TR>
-<!--End-->
\ No newline at end of file
+<!--End-->
Index: BirtWebViewer/webcontent/birt/pages/parameter/HiddenParameterFragment.jsp
===================================================================
--- BirtWebViewer/webcontent/birt/pages/parameter/HiddenParameterFragment.jsp	(revision 12247)
+++ BirtWebViewer/webcontent/birt/pages/parameter/HiddenParameterFragment.jsp	(working copy)
@@ -37,9 +37,22 @@
 		<INPUT TYPE="HIDDEN"
 			NAME="<%= encodedParameterName %>"
 			VALUE="<%= value %>"/>		
+		    <!-- For Mifos Birt report -->
+		    <font class="fontnormalRedBold">
+		    <%
+			    String message = request.getParameter("mifosErrorMessage");
+	 		    if (message != null && request.getAttribute("errorHasBeenShown") == null) { 
+	 		        request.setAttribute("errorHasBeenShown", "true");			    		 		    
+			    	String[] messages = message.split("~");
+			    	for(int i=0;i<messages.length;i++){	    
+			    		out.println("<li>" + messages[i] + "</li>");
+			    	}
+			    }
+		    %>
+		    </font>						
 	</TD>
 </TR>
 
 <%
 	}
-%>
\ No newline at end of file
+%>
Index: BirtWebViewer/webcontent/birt/pages/parameter/ParameterGroupFragment.jsp
===================================================================
--- BirtWebViewer/webcontent/birt/pages/parameter/ParameterGroupFragment.jsp	(revision 12247)
+++ BirtWebViewer/webcontent/birt/pages/parameter/ParameterGroupFragment.jsp	(working copy)
@@ -22,7 +22,7 @@
 -----------------------------------------------------------------------------%>
 <jsp:useBean id="fragments" type="java.util.Collection" scope="request" />
 <jsp:useBean id="attributeBean" type="org.eclipse.birt.report.context.BaseAttributeBean" scope="request" />
-
+<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
 <%-----------------------------------------------------------------------------
 	Content fragment
 -----------------------------------------------------------------------------%>
@@ -62,6 +62,17 @@
 	}
 %>	
 		<TABLE CLASS="birtviewer_parameter_dialog_Label">
+		<TR><TD COLSPAN="2" ALIGN="CENTER">
+
+		<c:if test="${reportErrors ne null}">
+			Error occurred while generating report
+			<div align="left"><ul class="fontnormalRedBold">
+			<c:forEach items="${reportErrors.allErrorMessages}" var="error">
+				<li><c:out value="${error}"/></li>
+			</c:forEach>
+			</ul></div>
+		</c:if>
+		</TD></TR>
 		<%
 			if ( fragments != null )
 			{
@@ -78,4 +89,4 @@
 		%>
 		</TABLE>
 	</TD>
-</TR>
\ No newline at end of file
+</TR>
Index: BirtWebViewer/webcontent/birt/pages/parameter/TextBoxParameterFragment.jsp
===================================================================
--- BirtWebViewer/webcontent/birt/pages/parameter/TextBoxParameterFragment.jsp	(revision 12247)
+++ BirtWebViewer/webcontent/birt/pages/parameter/TextBoxParameterFragment.jsp	(working copy)
@@ -27,17 +27,11 @@
 	String encodedParameterName = ParameterAccessor.htmlEncode( parameterBean.getName( ) );
 %>
 <TR>
-	<TD NOWRAP>
-	<!-- For Mifos Birt reports hide
+	<!--<TD NOWRAP>
 		<IMG SRC="birt/images/parameter.gif" ALT="<%= parameterBean.getDisplayName( ) %>" TITLE="<%= parameterBean.getToolTip( ) %>"/>
-	-->	
-	</TD>
-	<TD NOWRAP>
-	    <!-- For Mifos Birt reports hide
-		<FONT TITLE="<%= parameterBean.getToolTip( ) %>">
-		
-		<LABEL FOR="<%= encodedParameterName %>"><%= parameterBean.getDisplayName( ) %>:</LABEL></FONT>
-		-->	
+	</TD>-->
+	<TD NOWRAP class = "fontnormal" align="right">
+		<FONT TITLE="<%= parameterBean.getToolTip( ) %>"><LABEL FOR="<%= encodedParameterName %>"><%= parameterBean.getDisplayName( ) %>:</LABEL></FONT>
 		<%-- is required --%>
 		<%
 		if ( parameterBean.isRequired( ) )
@@ -48,9 +42,9 @@
 		}
 		%>
 	</TD>
-</TR>
+<!--</TR>
 <TR>
-	<TD NOWRAP></TD>
+	<TD NOWRAP></TD>-->
 	<TD NOWRAP WIDTH="100%">
 <%
 	if ( parameterBean.allowNull( ) )
@@ -81,7 +75,6 @@
 <%
 	}
 %>
-<!-- For Mifos Birt reports hide
 		<INPUT CLASS="BirtViewer_parameter_dialog_Input"
 			TYPE="<%= parameterBean.isValueConcealed( )? "PASSWORD" : "TEXT" %>"
 			NAME="<%= encodedParameterName %>"
@@ -90,43 +83,7 @@
 			VALUE="<%= ParameterAccessor.htmlEncode( ( parameterBean.getValue( ) == null )? "" : parameterBean.getValue( ) ) %>" 
 			<%= ( parameterBean.allowNull( ) && parameterBean.getValue( ) == null )? "DISABLED='true'" : "" %>
             >
--->
-<!-- For Mifos Birt reports add-->
-        <table width="70%" cellspacing="0" cellpadding="0" border="0">
-             <tbody>
-                  <tr>
-                    <td class="headingorange" width="70%" valign="top" height="24" align="left">
-                        <LABEL><%= ParameterAccessor.htmlEncode( ( parameterBean.getValue( ) == null )? "" : parameterBean.getValue( ) ) %></LABEL>
-                        <br/>
-                    </td>
-                  </tr>
-             </tbody>
-         </table>
-         <div class="fontnormal">
-         <LABEL>Enter the parameters on which the report will be generated. The report will be generated as a pdf. 
-		     <FONT COLOR="red"><LABEL>*</LABEL></FONT><LABEL>Fields marked with an asterisk are required. </LABEL>
-             </br>
-         </div>
-         <div class="fontnormalbold">
-             </br>
-             <LABEL>&nbsp;Generate Report:</LABEL>
-         </div>
-         <!-- For Mifos Birt report -->
-	    <font class="fontnormalRedBold">
-	    <%
-		    String message = request.getParameter("message");
-		    if (message != null) {
-		    	String[] messages = message.split("~");
-		    	for(int i=0;i<messages.length;i++){
-	    %>
-	    <%
-		    		out.println("<li>" + messages[i] + "</li>");
-		    	}
-		    }
-	    %>
-	    </font>
-	    <!-- END -->
-<!-- End -->
+
 <%
 	if ( parameterBean.allowNull( ) && !parameterBean.allowBlank( ) )
 	{
@@ -153,4 +110,4 @@
 	}
 %>
 	</TD>
-</TR>
\ No newline at end of file
+</TR>
Index: BirtWebViewer/webcontent/birt/ajax/ui/dialog/BirtParameterDialog.js
===================================================================
--- BirtWebViewer/webcontent/birt/ajax/ui/dialog/BirtParameterDialog.js	(revision 12247)
+++ BirtWebViewer/webcontent/birt/ajax/ui/dialog/BirtParameterDialog.js	(working copy)
@@ -541,8 +541,14 @@
 				param.value = this.__parameter[i].value;
 				
 				//replace the URL parameter			
-				var reg = new RegExp( "&" + param.name + "[^&]*&*", "g" );
-				action = action.replace( reg, "&" );
+				// commented - let's not remove query param from URL even if
+				// the same param exists as POST param, because the cascade param
+				// dropdown does not send the userId if it's only a hidden param
+				
+				//var reg = new RegExp( "&" + param.name + "[^&]*&*", "g" );
+				//action = action.replace( reg, "&" );
+				
+				// end comment
 			}
 		}
 
@@ -605,4 +611,4 @@
 		birtUtility.setButtonsDisabled ( "navigationBar", false );		
 	}
 }
-);
\ No newline at end of file
+);
Index: BirtReportDesign/LayoutReport.rptconfig
===================================================================
--- BirtReportDesign/LayoutReport.rptconfig	(revision 0)
+++ BirtReportDesign/LayoutReport.rptconfig	(revision 0)
@@ -0,0 +1,3 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!-- Written by Eclipse BIRT 2.0 -->
+<report xmlns="http://www.eclipse.org/birt/2005/design" version="3.2.6" id="1"/>
